#pragma once
#include "Orbitersdk.h"
#include <vector>
#include <string>


#define YEAR ((((__DATE__ [7] - '0') * 10 + (__DATE__ [8] - '0')) * 10 \
+ (__DATE__ [9] - '0')) * 10 + (__DATE__ [10] - '0'))


#define MONTH (__DATE__ [2] == 'n' ? (__DATE__ [1] == 'a' ? 1 : 6) \
: __DATE__ [2] == 'b' ? 2 \
: __DATE__ [2] == 'r' ? (__DATE__ [0] == 'M' ? 3 : 4) \
: __DATE__ [2] == 'y' ? 5 \
: __DATE__[2] == 'l' ? 7 \
: __DATE__[2] == 'g' ? 8 \
: __DATE__[2] == 'p' ? 9 \
: __DATE__[2] == 't' ? 10 \
: __DATE__[2] == 'v' ? 11 : 12)

#define DAY ((__DATE__ [4] == ' ' ? 0 : __DATE__ [4] - '0') * 10 \
+ (__DATE__ [5] - '0'))

#define VERSION (((YEAR - 2000) * 100 + MONTH) * 100 + DAY)

#define MAXLEN 1024
#define SECTLEN 8192

using namespace std;

struct TD_Pts_Definitions {
	int n_points;
	vector<TOUCHDOWNVTX> tdvtx;
	TD_Pts_Definitions() {
		n_points = 0;
		tdvtx.clear();
	}
};

class TD_Pts_Updater: public oapi::Module {

public:
	TD_Pts_Updater(HINSTANCE hDLL);
	~TD_Pts_Updater();
	
	void clbkNewVessel(OBJHANDLE hVessel);
	void clbkSimulationStart(RenderMode mode);
	void clbkPostStep(double simt, double simdt, double mjd);
	bool ReadConfig(string name);
	TD_Pts_Definitions TD_def;
	void ApplyTouchdownPoints(OBJHANDLE hVessel);
	void VerifyVessel(OBJHANDLE hVessel);
	UINT frame_counter;
	bool first_verify;
	

};
